apeman-doc
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-cmd-labo/apeman-doc
[bd_travis_url]: http://travis-ci.org/apeman-cmd-labo/apeman-doc
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-cmd-labo/apeman-doc.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-cmd-labo/apeman-doc
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-cmd-labo/apeman-doc.svg?token=
[bd_license_url]: https://github.com/apeman-cmd-labo/apeman-doc/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-cmd-labo/apeman-doc
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-cmd-labo/apeman-doc.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-cmd-labo/apeman-doc.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-cmd-labo/apeman-doc
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-cmd-labo/apeman-doc.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-doc
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-doc.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Document generator for apeman.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

Install apeman-doc module via [npm][npm_url].
```bash
$ npm install apeman-doc -g
```


[npm_url]: https://www.npmjs.com/

<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

1. Prepare an Apemanfile.js at your project root.
2. Run the command via CLI.

***Apemanfile.js***
```javascript
/** Example of Apemanfile.js */

'use strict'

module.exports = {
  $cwd: __dirname,
  $pkg: { /* ... */ },
  $proto: [ /* ... */ ],
  $api: { /* ... */ }
}

```

Then,

```bash
# Generate doc about current apemanfile.
$ apeman-doc apemanfile doc/apemanfile-doc.md
```


##### CLI Options

```bash
$ apeman-doc -h

  Usage: apeman-doc [options] 

  Generate project documentation.

  Options:

    -h, --help                           output usage information
    -V, --version                        output the version number
    -o, --out <out>                      Output directory path.
    -c, --configuration <configuration>  Pathname of Apemanfile
    -C, --context <context>              Pathname of mock context file.

  Examples:

    $ apeman-doc -o doc/apdoc.md                    # Generate apemanfile doc.


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Programmatic API.md.hbs" Start -->

<a name="section-doc-guides-03-programmatic-a-p-i-md"></a>

Programmatic API
---

apeman-doc also provide programmatic API.

Firstly, install the module locally.

```bash
$ npm install apeman-doc --save-dev
```

Then,

```javascript
'use strict'

const apemanDoc = require('apeman-doc')

apemanDoc("apemanfile", "doc/apemanfile-doc.md", {}).then(() => {
    /* ... */
})
```


##### Programmatic Options

| Key | Description | Default |
| --- | ----------- | ------- |
| out | Output directory path. | doc/apdoc.md |
| configuration | Pathname of Apemanfile |  |
| context | Pathname of mock context file. |  |


<!-- Section from "doc/guides/03.Programmatic API.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-cmd-labo/apeman-doc/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]
+ [apeman-cmd-labo][apeman_cmd_labo_url]

[apeman_url]: http://github.com/apeman-labo/apeman
[apeman_cmd_labo_url]: http://github.com/apeman-cmd-labo

<!-- Links End -->
